#include <iostream>
#include <vector>
#include <unordered_set>

using namespace std;

int main() {
    int n, m, k, u, v;
    cin >> n >> m >> k;
    vector <unordered_set <int> > g1(n), g(n), g2(n);
    for (int i = 0; i < m; i++) {
        cin >> v >> u;
        g1[u - 1].insert(v - 1);
        g1[v - 1].insert(u - 1);
    }
    for (int i = 0; i < k; i++) {
        cin >> v >> u;
        g2[u - 1].insert(v - 1);
        g2[v - 1].insert(u - 1);
    }
    for (int i = 0; i < n; i++) {
        for (int j : g1[i]) {
            if (g2[i].find(j) == g2[i].end()) {
                g[i].insert(j);
                g[j].insert(i);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j : g2[i]) {
            if (g1[i].find(j) == g1[i].end()) {
                g[i].insert(j);
                g[j].insert(i);
            }
        }
    }
    vector < vector <int> > ans;
    for (int i = 0; i < n; i++) {
        if (g[i].size() % 2) {
            cout << "NO";
            return 0;
        }
        while (g[i].size() != 0) {
            u = *g[i].begin();
            g[i].erase(g[i].begin());
            v = *g[i].begin();
            g[i].erase(g[i].begin());
            ans.push_back({i, u, v});
            g[u].erase(i);
            g[v].erase(i);
            if (g[u].find(v) == g[u].end()) {
                g[u].insert(v);
                g[v].insert(u);
            } else {
                g[u].erase(v);
                g[v].erase(u);
            }
        }
    }
    cout << "YES\n" << ans.size() << '\n';
    for (auto i : ans) {
        cout << i[0] + 1 << ' ' << i[1] + 1 << ' ' << i[2] + 1 << '\n';
    }
}