#define GLIBCXX_DEBUG
#include <bits/stdc++.h>
using namespace std;
#define int long long
#define forn(i,s,f) for (int i=(s); i<(f); ++i)
#define ENDL " \n"

const int N=10;
vector<vector<char>> a(N+2, vector<char>(N+2, '.'));

bool ok(int i, int j) {
    if (a[i+1][j+1]=='#' or a[i-1][j-1]=='#' or a[i-1][j+1]=='#' or a[i+1][j-1]=='#') {
        return false;
    }
    int cnt=0;
    if (a[i-1][j]=='#') {
        ++cnt;
    }
    if (a[i+1][j]=='#') {
        ++cnt;
    }
    if (a[i][j-1]=='#') {
        ++cnt;
    }
    if (a[i][j+1]=='#') {
        ++cnt;
    }
    if (cnt>2) {
        return false;
    }
    return true;
}

void solve() {
    for(int i = 1; i <= N; ++i){
        for(int j = 1; j <= N; ++j){
            cin >> a[i][j];
        }
    }
    vector<int> mem(5, 0);
    int curcnt, curi, curj;
    vector<vector<bool>> used(N+1, vector<bool>(N+1, false));
    forn(i,1,N+1) {
        forn(j,1,N+1) {
            if (a[i][j]=='#' and !used[i][j]) {
                curi=i;
                curj=j;
                curcnt=1;
                used[i][j]=true;
                if (!ok(i, j)) {
                    cout<<"NO" ;
                    return;
                }
                if (a[i+1][j]=='#') {
                    curi=i+1;
                    while (a[curi][j]=='#') {
                        used[curi][j]=true;
                        if (!ok(curi, j)) {
                            cout<<"NO";
                            return;
                        }
                        ++curcnt;
                        ++curi;
                    }
                }
                curi=i;
                curj=j;
                if (a[i][j+1]=='#') {
                    curj=j+1;
                    while (a[i][curj]=='#') {
                        used[i][curj]=true;
                        if (!ok(i,curj)) {
                            cout<<"NO" ;
                            return;
                        }
                        ++curcnt;
                        ++curj;
                    }
                }
                if (curcnt>4) {
                    cout<<"NO" ;
                    return;
                } else {
                    ++mem[curcnt];
                }
                if (curcnt==1) {
                    if (mem[curcnt]>4) {
                        cout<<"NO" ;
                        return;
                    }
                }
                if (curcnt==2) {
                    if (mem[curcnt]>3) {
                        cout<<"NO" ;
                        return;
                    }
                }
                if (curcnt==3) {
                    if (mem[curcnt]>2) {
                        cout<<"NO" ;
                        return;
                    }
                }
                if (curcnt==4) {
                    if (mem[curcnt]>1) {
                        cout<<"NO" ;
                        return;
                    }
                }
            }
        }
    }
    forn(i,1,5) {
        if (mem[i]!=5-i) {
            cout<<"NO" ;
            return;
        }
    }
    cout<<"YES" ;
}

signed main(){
   /* ios::sync_with_stdio(false);
    cin.tie(nullptr);*/
    int test=1;
    //cin>>test;
    forn(i,0,test) {
        solve();
    }
    return 0;
}
