
#include "bits/stdc++.h"
#include "bits/extc++.h"

using namespace std;
using namespace __gnu_pbds;

mt19937 rnd(NULL);

#define int long long
#define mp make_pair
#define pb push_back

int inf = 10000000000;

struct SegmentTree{
    vector<int> a;
    vector<int> d;

    void buildTree(int v,int l,int r){
        if(r-l==1) {
            d[v] = a[l];
            return;
        }

        int m =(l+r) / 2;

        buildTree(2*v+1,l,m);
        buildTree(2*v+2,m,r);

        d[v] = max(d[2*v+1],d[2*v+2]);
    }

    int findAns(int v,int l,int r,int tl,int tr){
        if(r <= tl || l >= tr){
            return -1;
        }

        if(l >= tl && r <= tr){
            return d[v];
        }

        int m = (l+r) / 2;
        return max(findAns(2*v+1,l,m,tl,tr),findAns(2*v+2,m,r,tl,tr));
    }


};


bool cmp(pair<pair<int,int>,int> a,pair<pair<int,int>,int> b){
    return a.first.second < b.first.second;
}

int32_t main(){
    cout.sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<int> h(n);
    vector<int> c(n);

    for(int i=0;i<n;i++){
        cin >> h[i];
    }

    for(int i=0;i<n;i++){
        cin >> c[i];
    }
    SegmentTree tree;
    tree.a = h;
    tree.d = vector<int> (4*n);
    tree.buildTree(0,0,n);

    vector<pair<pair<int,int>,int>> segs(0);
    for(int i=0;i<n;i++){
        int l = i,r=n;
        while(r-l > 1){
            int m =(l+r) / 2;
            if(tree.findAns(0,0,n,i+1,m+1) < h[i]){
                l = m;
            }else{
                r = m;
            }
        }
        segs.push_back({{i,l},c[i]});
    }

    for(int i=0;i<n;i++){
        int l = -1,r=i;
        while(r-l > 1){
            int m =(l+r) / 2;
            if(tree.findAns(0,0,n,m,i) < h[i]){
                r = m;
            }else{
                l = m;
            }
        }
        segs.push_back({{r,i},c[i]});
    }

    sort(segs.begin(),segs.end());

  //  for(int i=0;i<segs.size();i++){
  //      cout << segs[i].first.first << " " << segs[i].first.second << " " << segs[i].second << endl;
  //  }

    vector<pair<pair<int,int>,int>> segs2 = segs;
    sort(segs2.begin(),segs2.end(),cmp);


    vector<int> dp(n);
    set<int> sd;
    int ti = 0;
    int tj = 0;
    for(int i=0;i<n;i++){
        while(ti < segs.size() && segs[ti].first.first <= i){
            if(segs[ti].first.first == 0) {
                sd.insert(segs[ti].second);
            }else{
                sd.insert(dp[segs[ti].first.first -1] + segs[ti].second);
            }
            ti++;
        }

       // for(auto p = sd.begin();p!=sd.end();p++){
      //      cout << *p << " ";
      //  }
      //  cout << endl;

        dp[i] = *sd.begin();


        while(tj < segs2.size() && segs2[tj].first.second <= i){
            if(segs2[tj].first.first == 0) {
                sd.erase(segs2[tj].second);
            }else{
                sd.erase(dp[segs2[tj].first.first -1] + segs2[tj].second);
            }
            tj++;
        }
  //  cout << "here" << endl;

    }

    cout << dp[n-1] << endl;


}
