#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;
using namespace std;

bool invec(vector<ll> a, ll x){
    for(int i=0; i<a.size(); ++i){
        if(a[i]==x){
            return true;
        }
    }
    return false;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m;
    cin>>n>>m;
    double r;
    cin>>r;
    ll cnt=0;
    vector<pair<ll, ll>> h;
    for(int i=0; i<n; ++i){
        ll a, b;
        cin>>a>>b;
        h.push_back({a, b});
        cnt=max(cnt, a);
    }
    vector<pair<ll, ll>> g(100000+1, {0,0});
    for(auto x : h){
        g[x.first-1]={x.first,x.second};
    }

    //vector<double> res(1000000000);
    //res[0]=0;
    vector<ll> days(m);
    for(int i=0; i<m; ++i){
        cin>>days[i];
    }
    sort(days.begin(), days.end());
    ld now=0;
    ld last=0;
    if(r==0){
        for(int i=0; i<m; ++i){
            cout<<0<<"\n";
        }
    }else {

        for (int i = 1; i < days[days.size()-1]+2; ++i) {
            now = (1 - r) * last + r * g[i-1].second;
            last = now;
            if (invec(days, i)) {
                cout << now << "\n";
            }
        }
    }


    return 0;
}