#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include<sstream>
using namespace std;

#define maxI 2147483647
#define minI -2147483648
#define maxLL 9223372036854775807
#define minLL -9223372036854775808

typedef long long ll;
typedef long double ld;

struct sprs {
    vector<vector<pair<ll, ll>>> st;

    void init(ll n, vector<pair<ll, ll>> &arr) {
        st.resize(__lg(n) + 3, vector<pair<ll, ll>>(n, {0, 0}));
        st[0] = arr;
        for (ll lvl = 1; lvl <= __lg(n) + 1; ++lvl) {
            for (ll l = 0; l + (1 << lvl) - 1 <= n; ++l) {
                st[lvl][l] = max(st[lvl - 1][l], st[lvl - 1][l + (1 << (lvl - 1))]);
            }
        }
    };

    pair<ll, ll> f(ll l, ll r) {
        r++;
        ll k = __lg(r - l);
        pair<ll, ll> t = max(st[k][l], st[k][r - (1 << k)]);
        return t;
    }
};

ld pow2(ld a, ll b) {
    if (b == 1) {
        return a;
    }
    if (b == 0) {
        return 1;
    }
    ld x = pow2(a, b / 2);
    x *= x;
    if (b % 2 == 0) {
        return x;
    } else {
        return x * a;
    }
}

void sort(vector<ll> &arr) {
    sort(arr.begin(), arr.end());
}

void no() {
    cout << "-1";
    exit(0);
}

vector<ll> ans;
vector<vector<ll>> tree;

vector<pair<ll, ll>> frame;
vector<bool> used;
vector<ll> a;

ll hate;

void reCursion(vector<vector<ll>> &vec) {
    ans[0] = vec[hate - 1][0];
    used[1] = false;
    a[0] = ans[0];
    for (ll i = 1; i < hate; i++) {
        vector<pair<ll, ll>> last;
        for (ll v: tree[i]) {
            if (!used[v]) {
                if (i < hate - 1) {
                    used[v * 2 + 1] = false;
                    a[v * 2 + 1] = a[v];
                }
            } else {
                last.emplace_back(a[(v - 1) / 2], v);
            }
        }
        sort(last.begin(), last.end());
        for (ll j = 0; j < last.size(); j++) {
            if (vec[hate - i - 1][j] < last[j].first)
                no();
            used[last[j].second] = false;
            if (i < hate - 1) {
                used[last[j].second * 2 + 1] = false;
                a[last[j].second * 2 + 1] = vec[hate - i - 1][j];
            }
            ans[frame[last[j].second].first] = vec[hate - i - 1][j];
            a[last[j].second] = vec[hate - i - 1][j];
        }
    }
}

void down(ll v, ll l, ll r, ll h) {
    if (h >= hate)
        return;
    if (tree.size() <= h)
        tree.push_back({});
    tree[h].push_back(v);
    frame[v] = {l, r};
    down(v * 2 + 1, l, (l + r) / 2, h + 1);
    down(v * 2 + 2, (l + r) / 2 + 1, r, h + 1);
}

map<ll, ll> mp_;

ll check_mn(int l, int r, vector<ll>& arr) {
    ll mn;
    if (l == r) {
        mn = arr[l];
    } else
        mn = min(check_mn(l, (l + r) / 2, arr), check_mn((l + r) / 2 + 1, r, arr));
    mp_[mn]++;
    return mn;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n;
    cin >> n;
    vector<ll> arr(n);
    map<ll, ll> m;
    for (ll i = 0; i < n; ++i) {
        cin >> arr[i];
        m[arr[i]]++;
    }
    if (n == 1) {
        cout << arr[0];
        return 0;
    }
    ll n1 = n + 1;
    n1 /= 2;
    ans.resize(n1);
    hate = __lg(n1);
    hate++;
    if (m.size() != n1) {
        cout << "-1";
        return 0;
    }
    vector<vector<ll>> vec(hate);
    for (pair<ll, ll> i: m) {
        if (i.second > hate) {
            cout << "-1";
            exit(0);
        }
        vec[i.second - 1].push_back(i.first);
    }

    for (ll i = 0; i < hate; ++i) {
        sort(vec[i]);
    }
    ll pw = 1;
    if (vec[hate - 1].size() != 1) {
        cout << "-1";
        return 0;
    }
    for (ll i = 1; i < hate; ++i) {
        if (vec[hate - i - 1].size() != pw) {
            no();
        }
        pw += pw;
    }
    frame.resize(n);
    used.resize(n, true);
    a.resize(n);
    down(0, 0, n1 - 1, 0);
    reCursion(vec);
    for (ll i: ans)
        cout << i << " ";
    return 0;
}
