#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include<sstream>

using namespace __gnu_pbds;
using namespace std;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

#define maxI 2147483647
#define minI -2147483648
#define maxLL 9223372036854775807
#define minLL -9223372036854775808

mt19937 gen;

int ran(int n) {
    return uniform_int_distribution<int>(0, n - 1)(gen);
}

typedef long long ll;
typedef long double ld;

struct sprs {
    vector<vector<pair<ll, ll>>> st;

    void init(int n, vector<pair<ll, ll>> &arr) {
        st.resize(__lg(n) + 3, vector<pair<ll, ll>>(n, {0, 0}));
        st[0] = arr;
        for (int lvl = 1; lvl <= __lg(n) + 1; ++lvl) {
            for (int l = 0; l + (1 << lvl) - 1 <= n; ++l) {
                st[lvl][l] = max(st[lvl - 1][l], st[lvl - 1][l + (1 << (lvl - 1))]);
            }
        }
    };

    pair<ll, ll> f(int l, int r) {
        r++;
        int k = __lg(r - l);
        pair<ll, ll> t = max(st[k][l], st[k][r - (1 << k)]);
        return t;
    }
};

sprs tbl;
vector<int> c;

ll solve(int l, int r) {
    if (r < l)
        return 0;
    if (l == r)
        return c[l];
    pair<ll, ll> mx = tbl.f(l, r);
    ll left = solve(l, mx.second - 1) + c[mx.second];
    ll right = solve(mx.second + 1, r) + c[mx.second];
    return min(left, right);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n; cin >> n;
    c.resize(n);
    vector<pair<ll, ll>> arr(n);
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first;
        arr[i].second = i;
    }
    tbl.init(n, arr);
    for (int i = 0; i < n; i++)
        cin >> c[i];
    cout << solve(0, n - 1);
    return 0;
}
