#include <bits/stdc++.h>

using namespace std;

/*#include <bits/extc++.h>
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;*/

#define ll long long
#define ld long double
#define all(a) (a).begin(), (a).end()
#define endl '\n'
#define fast ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

mt19937 rnd(std::chrono::steady_clock::now().time_since_epoch().count());

vector<ll> c;

struct segtree{
    int n;
    vector <pair<int, int>> tree;
    vector <int> input;

    void build(int i, int l, int r) {
        if(l == r) {
            tree[i].first = input[l];
            tree[i].second = l;
            return;
        }

        int mid = (l + r) / 2;

        build(i * 2, l, mid);
        build(i * 2 + 1, mid + 1, r);
        if(tree[i * 2] != tree[i * 2 + 1]) {
            tree[i] = tree[i * 2].first > tree[i * 2 + 1].first ? tree[i * 2] : tree[i * 2 + 1];
        } else {
            tree[i] = c[tree[i * 2].second] > c[tree[i * 2 + 1].second] ? tree[i * 2 + 1] : tree[i * 2];
        }
    }

    segtree () {}

    void init(vector <int> a) {
        n = a.size();
        input = a;
        tree.resize(4 * n);
        build(1, 0, n - 1);
    }

    pair <int, int> get(int i, int l,int r, int left, int right) {
        if (left == l && right == r) {
            return tree[i];
        }
        if(left > r || l > right) {
           return {-1e9, -1};
        }

        int mid = (l + r) / 2;

        pair <int, int> p1 = get(i * 2, l, mid, left, min(mid, right));
        pair <int, int> p2 = get(i * 2 + 1,mid + 1, r, max(left, mid + 1),right);

        if(p1.first != p2.first) {
            return p1.first > p2.first ? p1 : p2;
        } else {
            return c[p1.second] > c[p2.second] ? p2 : p1;
        }
    }

    int get(int left, int right) {
        return get(1, 0, n - 1, left, right).second;
    }
};

segtree DO;

ll rec(int l, int r) {
    if (r == l) {
        return c[l];
    }
    int m = DO.get(l, r);
    if (l == m || m == r) {
        return c[m];
    }
    return c[m] + min(rec(l, m - 1), rec(m + 1, r));
}

int main() {
    fast;

    int n; cin >> n;
    vector<int> h(n);
    for (int i = 0; i < n; ++i) {
        cin >> h[i];
    }
    c.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> c[i];
    }
    DO.init(h);

    ll ans = rec(0, n - 1);
    cout << ans;
    return 0;

}