#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#define nl endl
#else
#define nl '\n'
#pragma GCC optimize("Ofast")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define _ <<" "<<
#define pb push_back
#define eb emplace_back
#define ll long long
#define ld long double
#define ull unsigned long long


void solve() {
    ll last = 0;
    ll n, m;
    ld r, rem = 0;
    cin >> n >> m >> r;

    vector<pair<ll, ll>> tmp(n);
    forn(i, n) cin >> tmp[i].first >> tmp[i].second;
    sort(all(tmp));

    vector<pair<ll, ld>> a(n + 1);
    a[0] = {0, 0};
    forn(i, n) {
        auto &[d, w] = tmp[i];
        rem *= pow(1 - r, d - last);
        rem += w * r;
        a[i + 1] = {d, rem};
        last = d;
    }

    while (m--) {
        ll q;
        cin >> q;
        int it = upper_bound(all(a), make_pair(q, LDBL_MAX)) - a.begin() - 1;
        ld ans = a[it].second * pow(1 - r, q - a[it].first);
        cout << ans << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);

    int t = 1;
//    cin >> t;
    while (t--) solve();
}