#include <bits/stdc++.h>
using namespace std;

vector<int> vec;
vector<long long> cost;

int fo(int a, int b)
{
    if(a == -1)
    {
        return b;
    }
    if(b == -1)
    {
        return a;
    }
    if(vec[a] < vec[b])
    {
        return b;
    }
    return a;
}

struct D_o
{
    int n;
    vector<int> t;

    D_o(int _n)
    {
        n = _n;
        t.resize(4 * n);
        build(0,0, n);
    }

    void build(int v, int tl, int tr)
    {
        if(tl + 1 == tr)
        {
            t[v] = tl;
            return;
        }

        int tm = (tl + tr) / 2;

        build(2 * v + 1, tl, tm);
        build(2 * v + 2, tm, tr);

        t[v] = fo(t[2 * v + 1], t[2 * v + 2]);
    }
    int get(int v, int tl, int tr, int l, int r)
    {
        if(tr <= l || r <= tl)
        {
            return -1;
        }
        if(l <= tl && tr <= r)
        {
            return t[v];
        }
        int tm = (tl + tr) / 2;

        return fo(get(2 * v + 1, tl, tm, l, r), get(2 * v + 2, tm, tr, l, r));
    }
};

long long ans(int l, int r, D_o &gg)
{
    if(l == r)
    {
        return 0;
    }
    int m = gg.get(0,0, gg.n, l, r);

    long long otv = cost[m] + min(ans(l, m, gg), ans(m+1, r, gg));

    return otv;

}

int main()
{
    int n;
    cin >> n;
    vec.resize(n);
    cost.resize(n);
    for(int i = 0; i < n; ++i)
    {
        cin >> vec[i];
    }
    for(int i  = 0; i < n; ++i)
    {
        cin >> cost[i];
    }

    D_o gg(n);

    cout << ans(0, n, gg);
}