#include <iostream>
#include <cmath>
#include <iomanip>
#include <string>
#include <deque>
#include <stack>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <bitset>

using namespace std;
using ll = long long;

ll c(ll m, ll n){
    if (m == 1 && n == 1){
        return 1;
    }
    if (m == 1){
        return (n*(n+1)) / 2 + n - 1;
    }
    if (n == 1){
        return (m*(m+1)) / 2 + m - 1;
    }
    return c(m, 1) + c(m, n-1) + n*m;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    vector <vector <char>> a(10, vector <char> (10));
    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            cin >> a[i][j];
        }
    }
    int f = 0;
    map <int, int> m;
    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            if (a[i][j] == '#') {
                int len = 1;
                if (i > 0) {
                    if (a[i - 1][j] != '.') {
                        f = 1;
                    }
                }
                if (j > 0) {
                    if (a[i][j - 1] != '.') {
                        f = 1;
                    }
                }
                a[i][j] = '@';
                if (i < 9 && a[i + 1][j] == '#') {
                    int k = i + 1;
                    while (k < 10 && a[k][j] == '#') {
                        a[k][j] = '@';
                        len++;
                        if (j < 9) {
                            if (a[k][j + 1] != '.') {
                                f = 1;
                            }
                            if (k > 0) {
                                if (a[k - 1][j + 1] != '.') {
                                    f = 1;
                                }
                            }
                            if (k < 9) {
                                if (a[k + 1][j + 1] != '.') {
                                    f = 1;
                                }
                            }
                        }
                        if (j > 0) {
                            if (a[k][j - 1] != '.') {
                                f = 1;
                            }
                            if (k > 0) {
                                if (a[k - 1][j - 1] != '.') {
                                    f = 1;
                                }
                            }
                            if (k < 9) {
                                if (a[k + 1][j - 1] != '.') {
                                    f = 1;
                                }
                            }
                        }
                        k++;
                    }
                    if (k < 9) {
                        if (a[k][j] != '.') {
                            f = 1;
                        }
                    }
                } else {
                    int k = j + 1;
                    while (k < 10 && a[i][k] == '#') {
                        len++;
                        a[i][k] = '@';
                        if (i < 9) {
                            if (a[i + 1][k] != '.') {
                                f = 1;
                            }
                            if (k > 0) {
                                if (a[i + 1][k - 1] != '.') {
                                    f = 1;
                                }
                            }
                            if (k < 9) {
                                if (a[i + 1][k + 1] != '.') {
                                    f = 1;
                                }
                            }
                        }
                        k++;
                    }
                    if (k < 9) {
                        if (a[i][k] != '.') {
                            f = 1;
                        }
                    }
                }
                m[len] += 1;
            }
        }
    }
    if (f == 0 && m[1] == 4 && m[2] == 3 && m[3] == 2 && m[4] == 1 && m.size() == 4) {
        cout << "YES";
    } else {
        cout << "NO";
    }
}