def fast_pow(x, pow):
    if pow == 0:
        return 1.0
    if pow == 1:
        return x
    if pow % 2 == 1:
        return fast_pow(x, pow - 1) * x
    else:
        k = fast_pow(x, pow // 2)
        return k * k

n, m = map(int, input().split())
r = float(input())
d = [[0, 0]]
for i in range(n):
    q, e = map(int, input().split())
    d.append([q, e])
n += 1
d.sort(key=lambda x: x[0])
pref = [0.0 for i in range(n + 1)]
pref[1] = d[0][1] * r
for i in range(2, n + 1):
    pref[i] = pref[i - 1] * fast_pow(1 - r, d[i - 1][0] - d[i - 2][0]) + d[i - 1][1] * r
qq = list(map(int, input().split()))
for i in range(m):
    q = qq[i]
    l = 0
    ri = n
    while ri - l > 1:
        m = (l + ri) // 2
        if d[m][0] > q:
            ri = m
        else:
            l = m
    print(pref[l + 1] * fast_pow(1 - r, q - d[l][0]), end=" ")