#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define fi first
#define se second
mt19937_64 rnd(chrono::steady_clock().now().time_since_epoch().count());

const ll INFLL = 2e18;
struct seg{
    int G;
    vector<ll> t;
    seg (int n) {
        G = (1 << (__lg(n) + 1));
        t.resize(2 * G, INFLL);
    }
    ll get(int ql, int qr) {
        ll ans = INFLL;
        for (ql += G, qr += G; ql <= qr; ql >>= 1, qr >>= 1) {
            if (ql & 1) ans = min(ans, t[ql++]);
            if (~qr & 1) ans = min(ans, t[qr--]);
        }
        return ans;
    }
    void change(int id, ll val) {
        id += G;
        t[id] = val;
        id >>= 1;
        for (; id; id >>= 1) t[id] = min(t[id * 2], t[id * 2 + 1]);
    }
};
template <typename _>
bool chmin(_ &a, _ b) {
    if (b < a) return a = b, true;
    return false;
}
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    vector<ll> h(n+1), c(n+1);
    for (int i = 1; i <= n; i++) cin >> h[i];
    for (int i = 1; i <= n; i++) cin >> c[i];
    vector<ll> dp(n+1, INFLL);
    dp[0] = 0;
    seg seg(n+1);
    vector<ll> st;
    vector<ll> mn;
    for (int i = 1; i <= n; i++) {
        while (st.size() > 0 && h[st.back()] < h[i]) st.pop_back(), mn.pop_back();
        if (st.size() == 0) {
            dp[i] = c[i];
        } else {
            chmin(dp[i], seg.get(st.back() + 1, i) + c[i]);
            chmin(dp[i], mn.back());
        }
        st.push_back(i);
        mn.push_back((mn.size() > 0 ? min(mn.back(), dp[i-1] + c[i]) : dp[i-1] + c[i]));
        seg.change(i, dp[i-1]);
    }
    cout << dp.back() << "\0n";
    return 0;
}