#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define fi first
#define se second
mt19937_64 rnd(chrono::steady_clock().now().time_since_epoch().count());

int dx[8] = {0, 0, -1, 1, 1, 1, -1, -1};
int dy[8] = {-1, 1, 0, 0, -1, 1, -1, 1};

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);

    int n, m;
    cin >> n >> m;
    vector<vector<char>> f(n, vector<char>(m));

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> f[i][j];
        }
    }

    using SLIME = array<pair<int, int>, 4>;

    map<SLIME, int> dist;

    auto check = [&](SLIME a) {
        int c = 0;
        for (int i = 0; i < 4; i++) {
            auto [x, y] = a[i];
            if (x < 0 || x >= n || y < 0 || y >= m) return false;
            if (f[x][y] == '#') return false;

            for (int j = i + 1; j < 4; j++) {
                if (a[i] == a[j]) return false;

                if ((abs(a[i].first - a[j].first) + abs(a[i].second - a[j].second)) == 1) {
                    c++;
                }
            }
        }
        return c >= 3;
    };

    deque<SLIME> q;
    SLIME start;
    start[0] = {0, 0};
    start[1] = {0, 1};
    start[2] = {1, 0};
    start[3] = {1, 1};
    q.push_back(start);
    dist[start] = 1;

    SLIME finish;
    finish[0] = {n - 2, m - 2};
    finish[1] = {n - 2, m - 1};
    finish[2] = {n - 1, m - 2};
    finish[3] = {n - 1, m - 1};

    while (!q.empty()) {
        SLIME cur = q.front();
        q.pop_front();

        //for (auto [x, y] : cur) cout << x << ' ' << y << '\n';
        //cout  << '\n';

        for (int i = 0; i < 4; i++) {
            for (int k = 0; k < 8; k++) {
                SLIME nv = cur;
                nv[i].first += dx[k];
                nv[i].second += dy[k];
                sort(nv.begin(), nv.end());
                if (check(nv) && !dist[nv]) {
                    dist[nv] = dist[cur] + 1;
                    q.push_back(nv);
                    if (nv == finish) {
                        cout << dist[finish] - 1;
                        return 0;
                    }
                }
            }
        }
    }

    cout << -1 << '\n';

    return 0;
}