#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define fi first
#define se second
mt19937_64 rnd(chrono::steady_clock().now().time_since_epoch().count());

void solve() {
    ll n, k;
    cin >> n >> k;
    set<pair<ll, ll>> s;
    set<pair<pair<ll, ll>, pair<ll, ll>>> s2;
    vector<ll> pos;

    auto del_seg = [&](ll l, ll r) {
        s2.erase({{(r - l) / 2, -l}, {l, r}});
        s.erase({l, r});
    };

    auto add_seg = [&](ll l, ll r) {
        if (l > r) return;

        s2.insert({{(r - l) / 2, -l}, {l, r}});
        s.insert({l, r});
    };

    add_seg(1, n);

    for (int query = 0; query < k; query++) {
        char t;
        cin >> t;

        if (t == '+') {
            ll ans, res = -1;

            auto update = [&](ll ind, ll d) {
                if (d > res || d == res && ind < ans) {
                    res = d;
                    ans = ind;
                }
            };

            if (s.begin()->first == 1) {
                ll l = s.begin()->first;
                ll r = s.begin()->second;
                update(1, r - l);
            }

            if (prev(s.end())->second == n) {
                ll l = prev(s.end())->first;
                ll r = prev(s.end())->second;
                update(n, r - l);
            }

            auto it = prev(s2.end());
            ll l = it->second.first;
            ll r = it->second.second;
            update((l + r) / 2, (r - l) / 2);

            auto seg = --s.upper_bound({ans, n});
            l = seg->first;
            r = seg->second;
            del_seg(l, r);
            add_seg(l, ans - 1);
            add_seg(ans + 1, r);

            pos.push_back(ans);
            cout << ans << '\n';
        } else {
            ll x;
            cin >> x;
            x--;
            ll l, r;
            l = r = pos[x];

            auto it = s.upper_bound({r, n});
            if (it != s.end()) {
                if (it->first == r + 1) {
                    r = it->second;
                    del_seg(it->first, it->second);
                }
            }

            it = s.upper_bound({r, n});
            if (it != s.begin()) {
                it--;
                if (it->second == l - 1) {
                    l = it->first;
                    del_seg(it->first, it->second);
                }
            }

            add_seg(l, r);
        }

        //for (auto [l, r] : s) cout << l << ' ' << r << '\n';
    }
}

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    solve();
}