#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    vector<int> nums(m);
    for (int i = 0; i < m; ++i)
        cin >> nums[i];
    sort(nums.begin(), nums.end());

    vector<int> ans;
    int count = 1;
    for (int i = 1; i < m; ++i) {
        if (nums[i] == nums[i - 1])
            ++count;
        else {
            if (count >= n)
                ans.push_back(nums[i - 1]);
            count = 1;
        }

    }
    if (count >= n)
        ans.push_back(nums.back());

    cout << ans.size() << '\n';
    for (int elem : ans)
        cout << elem << ' ';

    return 0;
}
