#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    long double r;
    cin >> r;
    vector<pair<int, int>> data(n);
    for (int i = 0; i < n; ++i)
        cin >> data[i].first >> data[i].second;
    sort(data.begin(), data.end());

    vector<pair<int, int>> days(m);
    for (int i = 0; i < m; ++i) {
        cin >> days[i].first;
        days[i].second = i;
    }
    sort(days.begin(), days.end());

    long double cur_w = 0;
    int p1 = 0;
    int cur_day = -1;
    cout.precision(30);
    for (int i = 0; i < m; ++i) {
        while (p1 < n and data[p1].first <= days[i].first) {
            cur_w *= pow((1 - r), data[p1].first - cur_day);
            cur_day = data[p1].first;
            cur_w += (long double) data[p1].second * r;
            ++p1;
        }
        cur_w *= pow(1 - r, days[i].first - cur_day);
        cur_day = days[i].first;
        cout << cur_w << ' ';
    }




    return 0;
}
