#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

void count(vector <int>& vec, int& cnt, vector <int>& s, int l, int r) {
	if (l < 0 or r < 0 or r > vec.size() or l > vec.size())
		return;
	if (r - l <= 1) {
		cnt += s[max(l, r)];
		return;
	}
	int max = l;
	for (int i = l; i <= r; i++) {
		if (vec[i] >= vec[max]) {
			max = i;
		}
	}
	cnt += s[max];
	if (max - l > r - max) {
		count(vec, cnt, s, max + 1, r);
	}
	else
		count(vec, cnt, s, l, max - 1);
}

int main() {
	int n;
	cin >> n;
	vector<int> h(n), c(n);
	for (int i = 0; i < n; i++) {
		cin >> h[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> c[i];
	}
	int cnt = 0;
	count(h, cnt, c, 0, n - 1);
	cout << cnt;
}