#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

int log(int x) {
    int cnt = 0;
    while (x % 2 == 0) {
        cnt++;
        x /= 2;
    }
    if (x == 1) return cnt;
    return -1;
}

int len;
vector<int> a;
vector<set<int>> dop;
int h;

void rec(int dady, int deep, int right) {
    if (deep > h) return;
    int tecpos = (dady + right) / 2;
    if (dop[deep].empty()) return;
    auto tmp = dop[deep].lower_bound(a[dady]);
    if (tmp == dop[deep].end()) return;
    a[tecpos] = *tmp;
    dop[deep].erase(tmp);

    if (dop[deep].empty()) return;
    tmp = dop[deep].lower_bound(a[len - dady - 1]);
    if (tmp == dop[deep].end()) return;
    a[len - tecpos - 1] = *tmp;
    dop[deep].erase(tmp);
    rec(dady, deep + 1, tecpos);
    rec(tecpos, deep + 1, right);
}

void solve() {
    int n;
    cin >> n;
    len = (n + 1) / 2;
    h = log(n + 1);
    vector<int> b(n);
    map<int, int> cnt;
    cnt.clear();
    for (auto &i: b) {
        cin >> i;
        cnt[i]++;
    }
    if (n == 1){
        cout << b[0];
        return;
    }
    dop.resize(h + 1);
    for (auto [val, num]: cnt) {
        if (num > h){
            cout << -1;
            return;
        }
        dop[h - num].insert(val);
    }
    if (dop[0].empty() || dop[1].empty()) {
        cout << -1;
        return;
    }
    a.resize(len);
    a[0] = *dop[0].begin();
    dop[0].erase(dop[0].begin());
    a[len - 1] = *dop[1].begin();
    dop[1].erase(dop[1].begin());
    rec(0, 2, len / 2);
    for (int i = 0; i < len; i++) {
        if (b[i] == 0) {
            cout << -1;
            return;
        }
    }
    for (int i = 0;i < len;i ++){
        cout << a[i] << " ";
    }
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
}
