#include <iostream>

using namespace std;

const int LEN = 10;

int ex(int i, int j) {
    return i >= 0 && i < 10 && j >= 0 && j < 10;
}

int ship(char** field, int i, int j, int d, int lx, int ly) {
    int** neigh = new int* [4];
    int cnt = 0;
    for (int x : {-1, 1}) {
        for (int y : {-1, 1}) {
            if (ex(i + x, j + y) && field[i + x][j + y] == '#') {
                return 5;
            }
        }
    }
    for (int x : {-1, 1}) {
        if (ex(i + x, j) && field[i + x][j] == '#') {
            neigh[cnt] = new int[2];
            neigh[cnt][0] = i + x;
            neigh[cnt++][1] = j;
        }
    }
    for (int y : {-1, 1}) {
        if (ex(i, j + y) && field[i][j + y] == '#') {
            neigh[cnt] = new int[2];
            neigh[cnt][0] = i;
            neigh[cnt++][1] = j + y;
        }
    }
    if (cnt == 2 && neigh[0][0] != neigh[1][0] && neigh[0][1] != neigh[1][1]) {
        return 5;
    }
    if (cnt == 0) {
        return 1;
    }
    if (d == 0) {
        if (cnt == 1) {
            return ship(field, neigh[0][0], neigh[0][1], d + 1, i, j);
        }
        for (int k = 0; k < cnt; k++) {
            if (neigh[k][0] != lx || neigh[k][1] != ly) {
                return ship(field, neigh[k][0], neigh[k][1], 0, i, j);
            }
        }
    } else if (cnt == 1 && neigh[0][0] == lx) {
        return d + 1;
    } else {
        for (int k = 0; k < cnt; k++) {
            if (neigh[k][0] != lx || neigh[k][1] != ly) {
                return ship(field, neigh[k][0], neigh[k][1], d + 1, i, j);
            }
        }
    }
}

int main() {
	char** field = new char*[LEN + 1];
	for (int i = 0; i < LEN; i++) {
        field[i] = new char[LEN + 1];
        cin >> field[i];
	}
    /*for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            if (field[i][j] == '#') {
                cout << ship(field, i, j, 0, -1, -1) << ' ';
            } else {
                cout << '.' << ' ';
            }
        }
        cout << '\n';
    }*/
    bool ans = 1;
    int ships[4] = { 0, 0, 0, 0 };
    for (int i = 0; i < 10; i++) {
        for (int j = 0; j < 10; j++) {
            if (field[i][j] == '#') {
                int sh = ship(field, i, j, 0, -1, -1);
                if (sh > 4) {
                    ans = 0;
                } else {
                    ships[sh - 1]++;
                }
            }
        }
    }
    if (ans && ships[0] == 4 && ships[1] == 6 && ships[2] == 6 && ships[3] == 4) {
        cout << "YES";
    } else {
        cout << "NO";
    }
}
