#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3,Ofast,unroll-loops")
#pragma GCC target("popcnt,avx,avx2,fma,bmi,bmi2")

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> pair_) {
    in >> pair_.first >> pair_.second;
    return in;
}
template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> pair_) {
    out << pair_.first << " " << pair_.second;
    return out;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &arr_) {
    for (auto &_ : arr_) {
        in >> _;
    }
    return in;
}
template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr_) {
    for (auto &_ : arr_) {
        out << _ << " ";
    }
    return out;
}

using ll = long long;
using ull = unsigned long long;
using ld = long double;
using str = string;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
//#define int ll

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define many int _; cin >> _; while(_--)

int main() {
    int n;
    cin >> n;
    int m, k;
    cin >> m >> k;
    vector<pair<int, int>> f(2 * (m + k) + 2);
    f[0] = {0, 0};
    for (int i = 0; i < m + k; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        f[2 * i + 1] = {x, y};
        f[2 * i + 2] = {y, x};
    }
    f[int(f.size()) - 1] = {n, n};
    sort(f.begin(), f.end());
    vector<pair<int, int>> h;
    for (int i = 1; i <= 2 * (m + k); i++) {
        if ((f[i] != f[i - 1]) && (f[i] != f[i + 1])) {
            h.push_back(f[i]);
        }
    }
    vector<vector<int>> g(n);
    for (int i = 0; i < int(h.size()); i++) {
        g[h[i].first].push_back(h[i].second);
    }
    for (int i = 0; i < n; i++) {
        if (int(g[i].size()) % 2 != 0) {
            cout << "NO\n";
            return 0;
        }
    }
    vector<set<int>> g_right(n);
    for (int i = 0; i < n; i++) {
        for (auto u : g[i]) {
            if (u > i) {
                g_right[i].insert(u);
            }
        }
    }
    vector<vector<int>> vyvod;
    for (int i = 0; i < n; i++) {
        for (auto j = g_right[i].begin(); j != g_right[i].end(); j++, j++) {
            int i1, i2;
            i1 = *j;
            i2 = *(++j);
            --j;
            vyvod.push_back({i, i1, i2});
            if (g_right[i1].find(i2) == g_right[i1].end()) {
                g_right[i1].insert(i2);
            } else {
                g_right[i1].erase(i2);
            }
        }
    }
    cout << "YES\n";
    cout << (int)(vyvod.size()) << "\n";
    for (int i = 0; i < int(vyvod.size()); i++) {
        for (int j = 0; j < 3; j++) {
            cout << vyvod[i][j] + 1 << " ";
        }
        cout << "\n";
    }
}
