#include <bits/stdc++.h>
#define int int64_t
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
using namespace std;
const int N = 1000;
void solve();
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt = 1;
    while (tt--)
        solve();
}
int sz[N];
int p[N];
int f(int x) {
    return p[x] = (p[x] == x ? x : f(p[x]));
}
void unite(int x, int y) {
    x = f(x);
    y = f(y);
    if (x == y)
        return;
    if (sz[x] < sz[y])
        swap(x,y);
    p[y] = x;
    sz[x] += sz[y];
}
void solve() {
    for(int i = 0; i < N; i++) {
        sz[i]  = 1;
        p[i] = i;
    }
    vector<vector<int>> d(12, vector<int>(12));
    for (int i = 1; i < 11; i++) {
        string s;
        cin >> s;
        for (int j = 0; j < 10; j++)
            d[i][j + 1] = s[j] == '#';
    }
    for (int i = 1; i < 11; i++) {
        for (int j = 1; j < 11; j++) {
            if (d[i][j]) {
                if (d[i - 1][j - 1])
                    return void(cout << "NO");
                if (d[i + 1][j - 1])
                    return void(cout << "NO");
                if (d[i - 1][j + 1])
                    return void(cout << "NO");
                if (d[i + 1][j + 1])
                    return void(cout << "NO");
            }
        }
    }
    for (int i = 1; i < 11; i++) {
        for (int j = 1; j < 11; j++) {
            if (d[i][j] && d[i + 1][j])
                unite(i * 15 + j, i * 15 + j + 15);
            if (d[i][j] && d[i][j + 1])
                unite(i * 15 + j, i * 15 + j + 1);
            if (d[i][j] && d[i - 1][j])
                unite(i * 15 + j, i * 15 + j - 15);
            if (d[i][j] && d[i][j - 1])
                unite(i * 15 + j, i * 15 + j - 1);
        }
    }
    map<int, int> s;
    for (int i = 1; i < 11; i++) {
        for (int j = 1; j < 11; j++) {
            if (d[i][j])
                s[sz[f(i * 15 + j)]]++;
        }
    }
    if (s.size() == 4 && s[1] == 4 && s[2] == 6 && s[3] == 6 && s[4] == 4)
        cout << "YES";
    else
        cout << "NO";
}
