#include <iostream>
#include <valarray>

#define bigType unsigned long long

using namespace std;

int checkTens(bigType k) {
    int tens = 0;

    while (k != 0) {
        tens++;
        k /= 10;
    }

    return tens;
}

bigType revert(bigType k) {
    bigType last = k % 10;
    int tens = checkTens(k);
    int currentTen = 1;

    bigType result = 0;

    while (k != 0) {
        bigType desyat = pow(10, tens - currentTen);

        if (last == 2) {
            result += 5 * desyat;
        } else if (last == 5) {
            result += 2 * desyat;
        } else {
            result += last * desyat;
        }

        currentTen++;
        k /= 10;
        last = k % 10;
    }

    return result;
}

int main() {
    bigType k;
    cin >> k;

    if (k == 0) {
        cout << 0;
        return 0;
    }

    cout << revert(k);

    return 0;
}
